using System;
using System.Collections.Generic;
using System.Linq;
using System.Activities;
using Microsoft.TeamFoundation.Build.Client;

namespace Benday.TeamBuild2012.Activities
{

    [BuildActivity(HostEnvironmentOption.Agent)]
    public sealed class UpdateConnectionString : BuildActivityBase
    {
        public override string ActivityName
        {
            get { return "UpdateConnectionString"; }
        }

        [RequiredArgument]
        public InArgument<string> FileName { get; set; }

        [RequiredArgument]
        public InArgument<string> ConnectionName { get; set; }

        [RequiredArgument]
        public InArgument<string> ConnectionString { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            try
            {
                LogDebugMessage(context, "Initializing...");

                string tempFileName = FileName.Get(context);
                string tempConnectionName = ConnectionName.Get(context);
                string tempConnectionString = ConnectionString.Get(context);

                LogDebugVariableValue(context, "FileName", tempFileName);
                LogDebugVariableValue(context, "ConnectionName", tempConnectionName);
                LogDebugVariableValue(context, "ConnectionString", tempConnectionString);

                LogDebugMessage(context, "Calling SetConnectionString()...");

                DatabaseConfigurationFileEditor.SetConnectionString(
                    tempFileName, tempConnectionName, tempConnectionString);

                LogUsefulMessage(context, String.Format("Updated connection string '{0}' for '{1}'.", tempConnectionName, tempFileName));
            }
            catch (Exception ex)
            {
                LogException(context, ex);

                throw;
            }
        }
    }
}
