using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TeamBuild2012;
using System.Xml.Linq;
using Benday.TeamBuild2012.Activities;

namespace Benday.TeamBuild2012.UnitTests
{
    [TestClass]
    public class XmlUtilityFixture : UnitTestBase
    {
        public XmlUtilityFixture()
        {
        }

        [TestMethod]
        public void UpdateValueIfNewValueIsNotNullUpdatesNonNullValues()
        {
            XDocument document = XDocument.Parse(
                "<root attr1=\"attr1\" attr2=\"attr2\" />");

            var element = document.Root;

            AssertAttributeValue(element, "attr1", "attr1");
            AssertAttributeValue(element, "attr2", "attr2");

            XmlUtility.UpdateValueIfNewValueIsNotNull(element, "attr1", "attr1_updated");
            XmlUtility.UpdateValueIfNewValueIsNotNull(element, "attr2", "attr2_updated");

            AssertAttributeValue(element, "attr1", "attr1_updated");
            AssertAttributeValue(element, "attr2", "attr2_updated");
        }

        [TestMethod]
        public void UpdateValueIfNewValueIsNotNullSkipsNullValues()
        {
            XDocument document = XDocument.Parse(
                "<root attr1=\"attr1\" attr2=\"attr2\" />");

            var element = document.Root;

            AssertAttributeValue(element, "attr1", "attr1");
            AssertAttributeValue(element, "attr2", "attr2");

            XmlUtility.UpdateValueIfNewValueIsNotNull(element, "attr1", null);
            XmlUtility.UpdateValueIfNewValueIsNotNull(element, "attr2", null);

            AssertAttributeValue(element, "attr1", "attr1");
            AssertAttributeValue(element, "attr2", "attr2");
        }
    }
}
